$Lava::Speed = 100;
$Lava::Round = 0;
$Lava::Level = 0;
$Lava::TimeLeft = 30;

if(!isObject(FakeAdminClient))	//Create a fake client that can be passed to serverCmds, allowing
{
	new AiConnection(FakeAdminClient);
	FakeAdminClient.isAdmin = 1;
	FakeAdminClient.isSuperAdmin = 1;
}

function UpLava(%i)
{
	cancel($Lava::Up);
	if($Lava::Level >= 100)
	{
		$Lava::Level = 0;
		cancel($Lava::Up);
		return;
	}
	for (%j = 0; %j < ClientGroup.getcount(); %j++)
	{
		%clientTemp = ClientGroup.getObject(%j);
		commandToClient(%clientTemp, 'bottomPrint', "<font:impact:25>\c2Map: \c6" @ $Lava::DisplayName @ " \c2Round: \c6" @ $Lava::Round @ "/"@ $pref::Server::RisingLava::RoundLimit @ " \c2Lava Level: \c6" @ $Lava::Level , 1, true);
	}
	servercmdenvGUI_setvar(FakeAdminClient, WaterHeight, %i);
	$Lava::Level = %i;
	$Lava::Up = schedule($Lava::Speed/$Lava::Round ,0,UpLava,%i+0.01333);
}

function LavaWarmUp()
{
	cancel($Lava::WarmUp);
	for (%j = 0; %j < ClientGroup.getcount(); %j++)
	{
		%clientTemp = ClientGroup.getObject(%j);
		commandToClient(%clientTemp, 'bottomPrint', "<font:impact:25>\c6Time until lava starts rising: \c3" @ $Lava::TimeLeft, 1, true);
	}
	if($Lava::TimeLeft == 0)
	{
		messageAll('', "\c6The lava is now rising!");
		UpLava();
		cancel($Lava::WarmUp);
		return;
	}
	else if(mfloor($Lava::TimeLeft) == 20)
		messageAll('', "\c6The lava will begin to rise in\c3 20 \c6seconds.");
	else if(mfloor($Lava::TimeLeft) <= 10)
		messageAll('', "\c6The lava will begin to rise in \c3" @ $Lava::TimeLeft @ " \c6seconds.");
		
	$Lava::TimeLeft--;	
		
	$Lava::WarmUp = schedule(1000,0,LavaWarmUp);
}

if($pref::Server::RisingLava::RoundLimit $= "")
{
   $pref::Server::RisingLava::RoundLimit = 3;
}

$Lava::Initialized = false;

function Lava_BuildMapList()
{
	setmodpaths(getmodpaths()); //Checks for new maps
   %pattern = "Add-Ons/RisingLava_*/save.bls";
   
   $Lava::numMaps = 0;
   
   %file = findFirstFile(%pattern);
   while(%file !$= "")
   {
      $Lava::Map[$Lava::numMaps] = %file;
      $Lava::numMaps++;

      %file = findNextFile(%pattern);
   }
}

function Lava_DumpMapList()
{
   echo("");
   if($Lava::numMaps == 1)
      echo("1 Map");
   else
      echo($Lava::numMaps @ " Maps");
   for(%i = 0; %i < $Lava::numMaps; %i++)
   {
      %displayName = $Lava::Map[%i];
      %displayName = strReplace(%displayName, "Add-Ons/RisingLava_", "");
      %displayName = strReplace(%displayName, "/save.bls", "");
      %displayName = strReplace(%displayName, "_", " ");

      if(%i == $Lava::CurrentMap)
         echo(" >" @ %displayName);
      else
         echo("  " @ %displayName);
   }
   echo("");
}

function Lava_NextMap()
{
   $Lava::CurrentMap = mFloor($Lava::CurrentMap);
   $Lava::CurrentMap++;
   $Lava::CurrentMap = $Lava::CurrentMap % $Lava::numMaps;

   $Lava::ResetCount = 0;
   Lava_LoadMap_Phase1($Lava::Map[$Lava::CurrentMap]);
}

function Lava_LoadMap_Phase1(%filename)
{
   //suspend minigame resets
   $Lava::MapChange = 1;

   //put everyone in observer mode
   %mg = $DefaultMiniGame;
   if(!isObject(%mg))
   {
      error("ERROR: Lava_LoadMap( " @ %filename  @ " ) - default minigame does not exist");
      return;
   }
   for(%i = 0; %i < %mg.numMembers; %i++)
   {
      %client = %mg.member[%i];
      %player = %client.player;
      if(isObject(%player))
         %player.delete();

      %camera = %client.camera;
      %camera.setFlyMode();
      %camera.mode = "Observer";
      %client.setControlObject(%camera);
   }
   
   //clear all bricks 
   // note: this function is deferred, so we'll have to set a callback to be triggered when it's done
   BrickGroup_888888.chaindeletecallback = "Lava_LoadMap_Phase2(\"" @ %filename @ "\");";
	BrickGroup_888888.chaindeleteall();
}

function Lava_LoadMap_Phase2(%filename)
{
   echo("Loading RisingLava map " @ %filename);

   %displayName = %filename;
   %displayName = strReplace(%displayName, "Add-Ons/RisingLava_", "");
   %displayName = strReplace(%displayName, "/save.bls", "");
   %displayName = strReplace(%displayName, "_", " ");
   $Lava::DisplayName = %displayName;
   
   %loadMsg = "\c5Now loading \c6" @ %displayName;

   //read and display credits file, if it exists
   // limited to one line
   %creditsFilename = filePath(%fileName) @ "/credits.txt";
   if(isFile(%creditsFilename))
   {
      %file = new FileObject();
      %file.openforRead(%creditsFilename);

      %line = %file.readLine();
      %line = stripMLControlChars(%line);
      %loadMsg = %loadMsg @ "\c5, created by \c3" @ %line;

      %file.close();
      %file.delete();
   }

   messageAll('', %loadMsg);

   //load environment if it exists
   %envFile = filePath(%fileName) @ "/environment.txt"; 
   if(isFile(%envFile))
   {  
      //echo("parsing env file " @ %envFile);
      //usage: GameModeGuiServer::ParseGameModeFile(%filename, %append);
      //if %append == 0, all minigame variables will be cleared 
      %res = GameModeGuiServer::ParseGameModeFile(%envFile, 1);

      EnvGuiServer::getIdxFromFilenames();
      EnvGuiServer::SetSimpleMode();

      if(!$EnvGuiServer::SimpleMode)     
      {
         EnvGuiServer::fillAdvancedVarsFromSimple();
         EnvGuiServer::SetAdvancedMode();
      }
   }
   
   //load save file
   schedule(10, 0, serverDirectSaveFileLoad, %fileName, 3, "", 2, 1);
}


//some horrible /commands to change Maps and such
function serverCmdMapList(%client)
{
   for(%i = 0; %i < $Lava::numMaps; %i++)
   {
      %displayName = $Lava::Map[%i];
      %displayName = strReplace(%displayName, "Add-Ons/RisingLava_", "");
      %displayName = strReplace(%displayName, "/save.bls", "");
      %displayName = strReplace(%displayName, "_", " ");

      if(%i == $Lava::CurrentMap)
         messageClient(%client, '', " >" @ %i @ ". \c6" @ %displayName);
      else
         messageClient(%client, '', "  " @ %i @ ". \c6" @ %displayName);
   }
}
function serverCmdSetMap(%client, %i)
{
   if(!%client.isAdmin)
      return;

   if(mFloor(%i) !$= %i)
   {
      messageClient(%client, '', "Usage: /setMap <number>");
      return;
   }

   if(%i < 0 || %i > $Lava::numMaps)
   {
      messageClient(%client, '', "serverCmdSetMap() - out of range index");
      return;
   }

   messageAll( 'MsgAdminForce', '\c3%1\c2 changed the Map', %client.getPlayerName());
   
   $Lava::CurrentMap = %i - 1;
   Lava_NextMap();
}

function serverCmdNextMap(%client, %i)
{
   if(!%client.isAdmin)
      return;

   messageAll( 'MsgAdminForce', '\c3%1\c2 changed the Map', %client.getPlayerName());
   
   Lava_NextMap();
}

package GameModeRisingLavaPackage
{
   //this is called when save loading finishes 
   function GameModeInitialResetCheck()
   {
      Parent::GameModeInitialResetCheck();

      //if there is no Map list, attempt to create it
      if($Lava::numMaps == 0)
         Lava_BuildMapList();
      
      //if Maplist is still empty, there are no Maps
      if($Lava::numMaps == 0)
      {
         messageAll('', "\c5No RisingLava Maps available!");
         return;
      }

      if($Lava::Initialized)
         return;

      $Lava::Initialized = true;
      $Lava::CurrentMap = -1;
            
      Lava_NextMap();
   }

   //when we're done loading a new Map, reset the minigame
   function ServerLoadSaveFile_End()
   {
      Parent::ServerLoadSaveFile_End();

      //new Map has loaded, reset minigame
      if($DefaultMiniGame.numMembers > 0) //don't bother if no one is here (this also prevents starting at round 2 on server creation)
         $DefaultMiniGame.scheduleReset(); //don't do it instantly, to give people a little bit of time to ghost
   }

   function MiniGameSO::Reset(%obj, %client)
   {
      //make sure this value is an number
      $pref::Server::RisingLava::RoundLimit = mFloor($pref::Server::RisingLava::RoundLimit);

      //handle our race time hack
      %obj.raceStartTime = 0;

      //count number of minigame resets, when we reach the limit, go to next Map
      if(%obj.numMembers >= 0)
      {
         $Lava::ResetCount++;
      }

      if($Lava::ResetCount > $pref::Server::RisingLava::RoundLimit)
      {
         $Lava::ResetCount = 0;
         Lava_NextMap();
      }
      else
      {
		messageAll('', "\c6The lava will begin to rise in\c3 30 \c6seconds.");
		if($Lava::Round == $pref::Server::RisingLava::RoundLimit)
			$Lava::Round = 1;
		else
			$Lava::Round++;
		cancel($Lava::Up);
		servercmdenvGUI_setvar(FakeAdminClient, WaterHeight, 0);
		$Lava::Level = 0;
		$Lava::TimeLeft = 30;
		LavaWarmUp();
		Parent::Reset(%obj, %client);
      }	  
   }  
};
activatePackage(GameModeRisingLavaPackage);